/******************************************************************************
;  *   	@MCU				 : MC51F003A4
;  *   	@Create Date         : 2020.01.02
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@΢֧QQȺ   : 814641858
;  *    @΢ٷ̳       : http://bbs.sinomcu.com/
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *			          ڳʼ                            		
******************************************************************************/

#include "UART.h"

/************************************************
;  *    @Function Name       : UART1_Init
;  *    @Description         : 1ʼ
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
void UART1_Init(void)
{
	PCON |= DEF_SET_BIT7; //ʹUART1
	SCON_1 &= 0x3f;
	SCON_1 |= 0x50; //ʽ1  

	TMOD &= 0xCF;
	TMOD |= DEF_SET_BIT5; //ڲʱ  ʽ2
	TL1 = T1_Cnt;
	TH1 = T1_Cnt;
	TR1 = 1; //T1

	IE1 |= DEF_SET_BIT3; //UART1ж
}
/************************************************
;  *    @Function Name       : UART_Send_Byte
;  *    @Description         : ڷһֽ
;  *    @IN_Parameter      	 : Send_Data:͵
;  *    @Return parameter    :
;  ***********************************************/
void UART_Send_Byte(u8 send_data)
{
	uint16_t cnt = 0;
	SBUF_1 = send_data;		 //дݵUARTݼĴ
	while (!(SCON_1 & 0x02)) //ȴǰݷ
	{
		cnt++;
		if (cnt >= 50000) //16M 62.5mS
		{
			NOP(20);
			break; //ֹ
		}
	}
	SCON_1 &= ~DEF_SET_BIT1;
}
/************************************************
;  *    @Function Name       : UART_Send_Data
;  *    @Description         : 
;  *    @IN_Parameter      	 : *s:Ҫ͵ݣlen:ݳ
;  *    @Return parameter    :
;  ***********************************************/
void UART_Send_Data(char *s, u8 len)
{
	while (len)
	{
		UART_Send_Byte(*s++);
		len--;
	}
}
/************************************************
;  *    @Function Name       : UART_Send_String
;  *    @Description         : 
;  *    @IN_Parameter      	 : *s:Ҫ͵
;  *    @Return parameter    :
;  ***********************************************/
void UART_Send_String(char *s)
{
	while (*s) //ַ
	{
		UART_Send_Byte(*s++); //ݣַ+1
	}
}
/************************************************
;  *    @Function Name       : putchar   (ռ1kROM)
;  *    @Description         : printfضputchar
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
char putchar(char tx_data)
{
	SBUF_1 = tx_data; //дݵUARTݼĴ
	while (!(SCON_1 & 0x02)); //ȴǰݷ
	SCON_1 &= ~DEF_SET_BIT1;
	return tx_data;
}

void UART1_ISR(void) interrupt UART1_IRQn
{
	if (((SCON_1 & DEF_SET_BIT0) == DEF_SET_BIT0))
	{
		SCON_1 &= ~DEF_SET_BIT0;

		//յݴ
		if (UART_RX_END_FLAG == 0) //ûн
		{
			if (UART_RX_STA_FLAG == 0)
			{
				if (SBUF_1 == 0xff) //յ֡ͷ
				{
					UART_RX_STA_FLAG = 1;
				}
			}
			else
			{
				if (SBUF_1 == 0xff) //յ֡β
				{
					UART_RX_END_FLAG = 1;
				}
				else //
				{
					UART_RX_buff[UART_RX_len] = SBUF_1;
					UART_RX_len++;
				}
			}
		}
	}
}

/**************************** end of file *********************************************/
